.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\shell32.inc
include \masm32\include\gdi32.inc 
include  \masm32\include\winmm.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\gdi32.lib 
includelib  \masm32\lib\winmm.lib
DlgProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM

CarPos struct
 x dd ?
 y dd ?
CarPos ends


.const

IDD_DIALOG1			equ 101
IDI_ICON            equ 100
IDC_EDT1            equ 102
WAV                 equ 300
IDI_CURSOR          equ 400
.data
szTitle       db "Under Score Cursor", 0
.data?

hInstance			dd ?
hIcon				dd ?
hBrush1				dd ?


hcaret dd ?
lpfnEditAddr dd ?
hDC dd ?
CarDC dd ?
ps PAINTSTRUCT <>

cp CarPos <>
buffer_c db 250 dup(?)

X dd ?
red_flg db ?

EditHandle dd ?
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    INVOKE LoadIcon, eax, IDI_ICON 
    mov hIcon, eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

; Dialog procedure
; ------------------------------------------------------------------------------

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

mov  eax,uMsg
.if eax==WM_INITDIALOG
	INVOKE SetWindowText, hWnd, addr szTitle 
	INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon


invoke LoadBitmap,hInstance,400
mov hcaret,eax

invoke GetDlgItem,hWnd,102
mov EditHandle,eax	
push eax
call GetDC
mov hDC,eax
push eax
call CreateCompatibleDC
mov CarDC,eax
push hcaret
push eax
call SelectObject
push hcaret
call DeleteObject


push offset CarProc
push GWL_WNDPROC
push EditHandle
call SetWindowLong
mov lpfnEditAddr, eax


invoke SetTimer,hWnd,0,1000,0

.elseif eax == WM_TIMER
invoke BitBlt,hDC,X,cp.y,50,50,CarDC,0,0,SRCCOPY
invoke HideCaret,EditHandle

 .elseif eax==WM_COMMAND
mov edx,wParam
movzx eax,dx
shr edx,16
.if wParam == WM_KEYDOWN
	.elseif edx!=0
    invoke PlaySound,WAV,hInstance,SND_RESOURCE or SND_ASYNC

    .endif
	.elseif eax==WM_CTLCOLOREDIT
	invoke GetWindowLong,lParam,GWL_ID
	.if eax==102	
	.if hBrush1
	invoke DeleteObject,hBrush1
	.endif
	invoke SetBkMode,wParam,TRANSPARENT 
	invoke SetTextColor,wParam,0000FF00h 
	invoke CreateSolidBrush,00000000h 
	mov		hBrush1,eax
	ret
	.endif
	mov eax,FALSE
    ret
	.elseif uMsg==WM_CLOSE
	invoke EndDialog,hWnd,0

	.endif
xor eax,eax
ret
DlgProc endp
CarProc proc hCtl: dword,uMsg :DWORD,wParam :DWORD,lParam :DWORD
  
LOCAL tl:DWORD
LOCAL testBuffer[160]:BYTE
  
    ; -----------------------------
    ; Process control messages here
    ; -----------------------------
  
       cmp uMsg, WM_CHAR
       jne no_ch
  
       push offset cp
       call GetCaretPos
       
       cmp wParam,8; allow backspace
       jne @F
  
     
       cmp cp.x,0
       je show
       mov eax,cp.x
       sub eax,10
       mov X,eax
       jmp show
  @@:
 
       mov eax,cp.x
       add eax,10
       mov X,eax
       
 show: 
      
       
        push    1              ; bErase
        push    0               ; lpRect
        push    EditHandle; hWnd
        call    InvalidateRect
       
      
     
 no_ch:

    invoke CallWindowProc,lpfnEditAddr,hCtl,uMsg,wParam,lParam
  
    ret


CarProc endp
end start
